from enum import Enum

from addr_agent.agent_feature.methods.addr_v1_agent_update import RPCAddrV1AgentUpdateMethod
from addr_agent.agent_feature.methods.addr_v1_ansible_roles import RPCAddrV1AnsibleRolesMethod
from addr_agent.agent_feature.methods.addr_v1_ft_unblock_update import RPCAddrV1FtUnblockUpdateMethod
from addr_agent.agent_feature.methods.addr_v1_hwreport import RPCAddrV1HWReportMethod
from addr_agent.agent_feature.methods.addr_v1_nebula_create_ca import RPCAddrV1NebulaCreateCaMethod
from addr_agent.agent_feature.methods.addr_v1_nebula_create_host import RPCAddrV1NebulaCreateHostMethod
from addr_agent.agent_feature.methods.addr_v1_ping import RPCAddrV1PingMethod


class RPCMethod(Enum):
    ADDR_V1_PING = "addr.v1.ping"
    ADDR_V1_HWREPORT = "addr.v1.hwreport"
    ADDR_VI_AGENT_UPDATE = "addr.v1.agent_update"
    ADDR_VI_ANSIBLE_ROLES = "addr.v1.ansible_roles"

    ADDR_V1_NEBULA_CREATE_CA = "addr.v1.nebula_create_ca"
    ADDR_V1_NEBULA_CREATE_HOST = "addr.v1.nebula_create_host"

    ADDR_V1_FT_UNBLOCK_UPDATE = "addr.v1.ft_unblock.update"


RPC_METHOD_MAPPING = {
    RPCMethod.ADDR_V1_PING: RPCAddrV1PingMethod,
    RPCMethod.ADDR_V1_HWREPORT: RPCAddrV1HWReportMethod,
    RPCMethod.ADDR_VI_AGENT_UPDATE: RPCAddrV1AgentUpdateMethod,
    RPCMethod.ADDR_VI_ANSIBLE_ROLES: RPCAddrV1AnsibleRolesMethod,

    RPCMethod.ADDR_V1_NEBULA_CREATE_CA: RPCAddrV1NebulaCreateCaMethod,
    RPCMethod.ADDR_V1_NEBULA_CREATE_HOST: RPCAddrV1NebulaCreateHostMethod,

    RPCMethod.ADDR_V1_FT_UNBLOCK_UPDATE: RPCAddrV1FtUnblockUpdateMethod,
}
